/*
--------------------------------------------------------------------------------
 Includefile for LawnMaker to produce dandelions in with more ore less
 seeds still atached to the plants. The leaves are missing, because these
 plants are to be used between grasblades, where the leaves are simply not
 visible (this may be changed as desired).
--------------------------------------------------------------------------------

Contents:
Dand1, Dand2, ... Dand5
Dand1 shows the dandelion with a complete 'set' of seeds
Dand2 to -4 have some of their seeds blown away by the wind
Dand5 is completely 'clean'

Remark, that these Models are quite simple and therefore sholdn't be used for
closeups. When using these modells in LawnMaker, the coloring should be
prevented (by setting TypeColMap for theses plants to 0).
*/

// textures
// ---------------------------------------------------------
#declare Pb_Kern =  texture { pigment { rgb <0.97,1,0.75> } }
#declare Pb_Flaum =
    texture {
      pigment { crackle  metric 1 scale 0.1 turbulence 1
                color_map { [0.1, rgb 1]
                            [0.1, rgbf 1] }
              }
    }
#declare Pb_Samen =   texture { pigment { rgb <0.23,0.06,0> } }

// single parts
// ---------------------------------------------------------
#declare Pb_Kopf1 =
union {
  difference {
    sphere { 0, 1 }
    cone { <0,-1,0>, 0.9, <0,0,0>, 0 }
    texture { Pb_Flaum }
    no_shadow  double_illuminate
  }
  sphere { 0, 0.27
    scale <1,0.9,1>
    texture { Pb_Samen }
    normal { spiral2 5, 0.5 }
  }
}

#declare Pb_Kopf2 =
union {
  difference {
    sphere { 0, 1 }
    cone { <0,-1,0>, 0.9, <0,0,0>, 0 }
    cone { <0,-1,0>, 1.4, <0,0,0>, 0 rotate <80,45,0> } 
    texture { Pb_Flaum }
    no_shadow  double_illuminate
  }
  difference {
    sphere { 0, 0.27  scale <1,0.9,1> }
    cone { <0,-1,0>, 1.4, <0,0,0>, 0 rotate <80,45,0> } 
      texture { Pb_Samen }
      normal { spiral2 5, 0.5 }
  }
  sphere { 0, 0.2
    scale <1,0.7,1>
    texture { Pb_Kern }
  }
}

#declare Pb_Kopf3 =
union {
  difference {
    sphere { 0, 1 }
    cone { <0,-1,0>, 0.9, <0,0,0>, 0 }
    cone { <0,-1,0>, 3, <0,0,0>, 0 rotate <140,20,0> } 
    texture { Pb_Flaum }
    no_shadow  double_illuminate
  }
  difference {
    sphere { 0, 0.27  scale <1,0.9,1> }
    cone { <0,-1,0>, 3, <0,0,0>, 0 rotate <140,20,0> } 
      texture { Pb_Samen }
      normal { spiral2 5, 0.5 }
  }
  sphere { 0, 0.2
    scale <1,0.7,1>
    texture { Pb_Kern }
  }
}

#declare Pb_Kopf4 =
union {
  intersection {
    sphere { 0, 1 }
    cone { <0,-1,0>, 0.8, <0,0,0>, 0 rotate <140,-70,0> } 
    texture { Pb_Flaum }
    no_shadow  double_illuminate
  }
  intersection {
    sphere { 0, 0.27  scale <1,0.9,1> }
    cone { <0,-1,0>, 0.8, <0,0,0>, 0 rotate <140,-70,0> } 
      texture { Pb_Samen }
      normal { spiral2 5, 0.5 }
  }
  intersection {
    sphere { 0, 1 }
    cone { <0,-1,0>, 0.2, <0,0,0>, 0 rotate <100, 100,0> } 
    texture { Pb_Flaum }
    no_shadow  double_illuminate
  }
  intersection {
    sphere { 0, 0.27  scale <1,0.9,1> }
    cone { <0,-1,0>, 0.2, <0,0,0>, 0 rotate <100, 100,0> } 
      texture { Pb_Samen }
      normal { spiral2 5, 0.5 }
  }
  sphere { 0, 0.2
    scale <1,0.7,1>
    texture { Pb_Kern }
  }
}

#declare Pb_Kopf5 =
sphere { 0, 0.2
  scale <1,0.7,1>
  texture { Pb_Kern }
}

#declare Pb_Bluetenrand =
intersection {
  prism { linear_sweep  linear_spline   -1.5,  0,  10,
    < 0, 1>, < -0.2,  0.2>, < -0.8, 0.4>, < -0.3, -0.2>, < -0.7, -0.7>, 
    < 0, -0.3>, <0.7, -0.7>, <0.3, -0.2>, <0.8,  0.4>, <0.2, 0.2>
    scale 0.7
  }
  difference {
    sphere { 0, 0.6  scale <1,2,1> translate <0,-1.3,0> }
    sphere { 0, 0.58  scale <1,2,1> translate <0,-1.3,0> }
  }
  pigment { color rgb <0.14,0.45,0.04> }
}

#declare Pb_Stil =
intersection {
  torus { 2, 0.02 rotate <90,0,0> translate <2,0,0> }
  box { <-0.1,0,-0.1>, <0.5,1,0.1> }
  pigment {color rgb <0.4,0.6,0.1> }
}

// complete plants
// -----------------------
#declare Dand1 =
union {
  object { Pb_Kopf1       scale 0.2  rotate <0,0,-30>  translate <0.265,1,0> }
  object { Pb_Bluetenrand scale 0.2  rotate <0,0,-30>  translate <0.265,1,0> }
  object { Pb_Stil }
}

#declare Dand2 =
union {
  object { Pb_Kopf2       scale 0.2  rotate <0,0,-30>  translate <0.265,1,0> }
  object { Pb_Bluetenrand scale 0.2  rotate <0,0,-30>  translate <0.265,1,0> }
  object { Pb_Stil }
}

#declare Dand3 =
union {
  object { Pb_Kopf3       scale 0.2  rotate <0,0,-30>  translate <0.265,1,0> }
  object { Pb_Bluetenrand scale 0.2  rotate <0,0,-30>  translate <0.265,1,0> }
  object { Pb_Stil }
}

#declare Dand4 =
union {
  object { Pb_Kopf4       scale 0.2  rotate <0,0,-30>  translate <0.265,1,0> }
  object { Pb_Bluetenrand scale 0.2  rotate <0,0,-30>  translate <0.265,1,0> }
  object { Pb_Stil }
}

#declare Dand5 =
union {
  object { Pb_Kopf5       scale 0.2  rotate <0,0,-30>  translate <0.265,1,0> }
  object { Pb_Bluetenrand scale 0.2  rotate <0,0,-30>  translate <0.265,1,0> }
  object { Pb_Stil }
}
