/*
--------------------------------------------------------------------------------
Examplefile to show usage of LawnMaker 1.1
This creates a simple round grasspatch with only a few longer straws in it
--------------------------------------------------------------------------------
*/

#include "lawnmaker.inc"
#include "Halm1.inc"

#version 3.5;

global_settings {
  assumed_gamma 1.0
  max_trace_level 5
}
background { color rgb 1 }

// Only the necessary values are changed
#declare LawnStart = <-2, -2>;
#declare LawnStop  = < 2,  2>;
#declare LawnStepX = <0.1, 0.1>;
#declare LawnStepZ = <0.1, 0.1>;
/*
To create a round patch, a spherical pattern is used. By setting the outer
regions to 0, there are no plants there and thus there is no square patch of
plants.
*/
#declare LawnHeight = pigment { spherical scale 3 color_map { [0.4, rgb 0] [1, rgb 1] } }


// New coloring used for the straws
#declare LawnColor[4] =
  pigment { spotted turbulence 2  scale 0.5
            colour_map { [0.0 color rgb <0.95, 0.7, 0.25>]
                         [1.0 color rgb <0.9, 0.8, 0.3>] }
          }
 

#declare T = 6;
#declare TypeGeometry = array[T] { Blade1,     Blade2,      Blade3,    Blade4,    Blade5,    Halm1   }
#declare TypeWeight   = array[T] { 4,          4,           4,         3,         3,         0.2     }
#declare TypeSize1    = array[T] { <.7,.6,.7>, <.7,.5,.7>,  <.6,.4,.6>,<.6,.4,.6>,<.6,.4,.6>,<2,2,2> }
#declare TypeSize2    = array[T] { <1,1.5,1>,  <1,1.4,1>,   <1,1.2,1>, <1,1.1,1>, <1,1.1,1>, <3,3,3> }
#declare TypeColMap   = array[T] { 1,          1,           2,         2,         2,         4       }
#declare TypeTurn     = array[T] { <0, 360>,   <0, 360>,    <0, 360>,  <0, 360>,  <0, 360>,  <0, 360>}
#declare TypeIncline  = array[T] { <0, 50>,    <0, 30>,     <0, 10>,    <0,5>,    <-2,2>,    <-5,5>  }


// invoking LawnMaker and thus actually producing the grass
LawnMaker()


camera { location  <0.0, 5, -7> direction 1.5*z
  right x*image_width/image_height  look_at   <0.0, 0.9,  0.0>}

light_source {
  <-30, 30, -30>            
  color rgb <1, 1, 1>  
}

plane {  y, 0
  texture { pigment { bozo
                      color_map { [0, color rgb <0.3,0.2,0>]
                                  [1, color rgb <0.25,0.05,0>] } }
            finish { diffuse 0.8  ambient 0.1 }
  }
}  
