/*
--------------------------------------------------------------------------------
Examplefile to show usage of LawnMaker 1.2

This example demonstrates the excessive use of patterns to modell a small
grasspatch in almost every aspect.
The result is a round grasspatch wih the blades pointing outward from the center
and inklining more and more to the ground the more to the rim of the patch they
are planted.
--------------------------------------------------------------------------------
*/

#include "lawnmaker.inc"

#version 3.5;

global_settings {
  assumed_gamma 1.0
  max_trace_level 5
}
background { color rgb 1 }

// Only the necessary values are changed
#declare LawnStart = <-2, -2>;
#declare LawnStop  = < 2,  2>;
#declare LawnStepX = <0.06, 0.08>;
#declare LawnStepZ = <0.06, 0.08>;

#declare LawnPosStretch = 0.2;
#declare LawnPosition = pigment { cylindrical scale 3 color_map { [0.4, rgb 0] [1, rgb 1] } }

#declare LawnHeight = pigment { cylindrical scale 3 color_map { [0.4, rgb 0] [1, rgb 1] } 
                                turbulence 0.3 }
#declare LawnType   = pigment { cylindrical scale 3 color_map { [0.4, rgb 0] [1, rgb 1] }
                                turbulence 0.21 }
#declare LawnDirection   = pigment { radial color_map { [0, rgb 0] [1, rgb 1] }
                                     turbulence 0.6  }
#declare LawnInclination = pigment { cylindrical color_map { [0, rgb 0] [1, rgb 1] }
                                     turbulence 0.2 scale 3 }


#declare T = 3;
#declare TypeGeometry = array[T] { Blade3,     Blade2,      Blade1     }
#declare TypeWeight   = array[T] { 1,          2,           3          }
#declare TypeSize1    = array[T] { <1,.6,1>,   <1,.5,1>,    <1,.4,1>   }
#declare TypeSize2    = array[T] { <1,1.5,1>,  <1,1.4,1>,   <1,1.2,1>  }
#declare TypeColMap   = array[T] { 1,          1,           1          }
#declare TypeTurn     = array[T] { <0, 360>,   <0, 360>,    <0, 360>   }
#declare TypeIncline  = array[T] { <0, 30>,    <0, 20>,     <0, 10>    }

// invoking LawnMaker and thus actually producing the grass
LawnMaker()


camera { location  <0 , 3, -7> direction 1.5*z
  right x*image_width/image_height  look_at   <0.0, 0.2,  0.0>}

light_source {
  <-30, 30, -30>            
  color rgb <1, 1, 1>  
}

union {
  plane {  y, 0 }
  sphere{ 0, 1  scale <1.8,0.36,1.8>  translate <0,-0.16,0> }
    texture { pigment { bozo
                        color_map { [0, color rgb <0.3,0.2,0>]
                                    [1, color rgb <0.25,0.05,0>] } }
              finish { diffuse 0.8  ambient 0.1 }
    }
}  
